#!/usr/local/bin/perl
#
# sutf8.pl Shift JIS  UTF-8Ѵ for Perl Version 0.02
#             (this file encode: "EUC-JP")
#
#    Copyright (C) 2006 Sato-Siʤȡ
#     http://www2s.biglobe.ne.jp/~satosi/gmap/suft8.pl
#     sato-si@mth.biglobe.ne.jp
#
#   ѥե꡼ǤץݾʥХѥեޥ󥹤нˤϤޤ󡦡
#
#  ¹ԤˤϰʲΥեUnicode ConsortiumǸƤMicrosoft CP932ѴɽˤɬפǤ
#   ftp://ftp.unicode.org/Public/MAPPINGS/VENDORS/MICSFT/WINDOWS/CP932.TXT
$sjis2unicode_table_filename = 'CP932.TXT';
#
#  ͡ΥեϴĤʸʣ줿֤ˤʤäƤޤ̩ˤϤĴ٤
#

# Ѳǽʴؿ
#  &sjis2utf8(*str);		# $str Shift-JIS  UTF-8Ѵ
#  		&sjis2utf8(*str,1);		# $str Shift-JIS  UTF-8ѴBOMդ
#  &utf82sjis(*str);	# $str  UTF-8 Shift-JISѴ
#  &unicode_esc2sjis(*str);	# UNICODE escape줿Τ եJISѴ㡧%u3042ʤ (Shift-JIS) Ѵ
#  &unicode_esc2utf8(*str);	# UNICODE escape줿Τ UTF-8Ѵ㡧%u3042ʤ (UTF-8) Ѵ
#  		&unicode_esc2utf8(*str,1);	# UNICODE escape줿Τ UTF-8ѴBOMդ

# BOM Ȥ "\xEF\xBB\xBF" ƬˤĤ뤳ȤǡUTF-8ǡХȥλ򤷤Ƥ롣

#
#  
#   2006/3/14  Version 0.01 ꥸʥʥǥХåԽʬǤ Sato-Si
#   2006/3/20  Version 0.02 %u3042ΥǥĤɲ Sato-Si
#



	# ѥ
	#  ѡ http://www.asahi-net.or.jp/~DP8T-ASM/java/tips/UTF8.html
	#UTF-8Υ󥳡ǥ եޥå Unicode Unicodeӥå UTFӥå  
	#1Хȥ \u0\u7F 		0000 0000 0aaa bbbb 			0aaa bbbb  
	#2Хȥ \u80\u7FF		 0000 0aaa bbbb cccc 			110a aabb 10bb cccc  
	#3Хȥ \u800\uFFFF		 aaaa bbbb cccc dddd 		1110 aaaa 10bb bbcc 10cc dddd  




#
#  sjis2utf8 λȤ
#
#  &sjis2utf8(*str);

# BOMĤ硤&sjis2utf8(*str, 1);
#  BOMäƤΤϡХȥޡ餷
#  ȤߤϡեƬˡ"\xEF\xBB\xBF" ΣХȤĤǤ 㡧 print FILE "\xEF\xBB\xBF";

sub sjis2utf8
{
	local(*str, $need_bom) = @_;	# ѥ᡼ϥǡBOMĤ뤫ɤ
	my($i, @strArray, $index);

	if($sjs2utf8_x_x_init == 0)	# Ѵơ֥ޤ
	{
		my($s2u_line);
		my($comment);
		my($sjiscode);
		my($unicode);
		my($zero);

		open(CP932, $sjis2unicode_table_filename) || die "cannot open $sjis2unicode_table_filename";
		while(<CP932>) {
			chop;
			($s2u_line,$comment) = split('#');			# Ȥڤ	0x01	0x0001	#START OF HEADING
			($sjiscode,$unicode) = split('\t',$s2u_line);	# Ĥοʬ  0x01	0x0001	
			($zero,$sjiscode) = split('x',$sjiscode);	# Shift-JIS 0x01  xʬ뤳Ȥǡ001ʬ

			if($zero eq '0')	# ʸ 0x ǻϤޤȤΤߡͤǧ
			{
				($zero,$unicode) = split('x',$unicode);
				if($zero eq '0') {		# UNICODEοͤ 0xǻϤޤʤбΤʤѴɽϿʤ
					my($work) = hex($unicode);
					my($sjiscodenum) = hex($sjiscode);

					# ɤξͤ򸡽СCP932.TXTˤϡShift-JISɤνʣϤޤ
				#	if($_sjis2utf8_table[$sjiscodenum] ne '') {
				#		print "conflict Shift-JIS CODE! : $s2u_line#$comment\n";
				#	}

					if($work <= 0x7F) {
						$_sjis2utf8_table[$sjiscodenum] = pack("C1", $work);
					} elsif($work <= 0x7FF) {
						$_sjis2utf8_table[$sjiscodenum] = pack("C2", 0xc0|($work >> 6), 0x80|($work & 0x3f ) );
					} else {
						$_sjis2utf8_table[$sjiscodenum] = pack("C3", 0xe0|($work  >> 12), 0x80|(($work >> 6) & 0x3f), 0x80|($work & 0x3f ) );
					}
				}
			}
		}
		close(CP932);

		$sjs2utf8_x_x_init = 1;	# Ѵơ֥Ѥ
	}

	@strArray = unpack("C*",$str);	# ʸɲ

	$str = '';
	if($need_bom != 0) {
		# BOMɤɲ
		$str = "\xEF\xBB\xBF";
	}

	for($i = 0; $i < @strArray; $i++) {
		if($strArray[$i] >= 0x80) {	# 2Хʸ
			$index = $strArray[$i] * 0x100 + $strArray[$i+1];
			$i++;
		} else {
			$index = $strArray[$i];
		}
		$str .= $_sjis2utf8_table[$index];
	}
	
	$str;
}


sub loadutf82sjistable
{
		my($s2u_line);
		my($comment);
		my($sjiscode);
		my($unicode);
		my($zero);

		open(CP932, $sjis2unicode_table_filename) || die "cannot open $sjis2unicode_table_filename";
		while(<CP932>) {
			chop;
			($s2u_line,$comment) = split('#');
			($sjiscode,$unicode) = split('\t',$s2u_line);
			($zero,$sjiscode) = split('x',$sjiscode);

			if($zero eq '0')	#ʸ 0x ǻϤޤȤΤߡͭ
			{
				($zero,$unicode) = split('x',$unicode);
				if($zero eq '0') {
					my($unicodenum) = hex($unicode);
					# ɤξͤ򸡽СCP932.TXTϾͤǡ¸ߤޤ
				#	if($_unicode2sjis_table[$unicodenum] ne '') {
				#		print "conflict UNICODE CODE! : $s2u_line#$comment\n";
				#	}
					$_unicode2sjis_table[$unicodenum] = pack("H*", $sjiscode);
				}
			}
		}
		close(CP932);

		$utf82sjs_x_x_init = 1;	# Ѵơ֥Ѥ
}


# ȿ UTF-8 Shift-JISѴ

#  &utf82sjis(*str);


sub utf82sjis
{
	local(*str) = @_;
	my($i, @strArray, $index, $pre);

	if($utf82sjs_x_x_init == 0)	# Ѵơ֥ޤ
	{
		&loadutf82sjistable;
	}

	@strArray = unpack("C*",$str);	# ʸɲ
	$str = '';
	$pre = 0;
	# BOMɤХåפ롣
	if(@strArray > 3)
	{
		if($strArray[0] == 0xEF && $strArray[1] == 0xBB && $strArray[2] == 0xBF) {
			$pre = 3;
		}
	}

	for($i = $pre; $i < @strArray; $i++) {
		if(($strArray[$i] & 0x80) == 0 ) {	# 1byte
			$index = $strArray[$i];
		} elsif(($strArray[$i] & (0xe0)) == (0xc0)) {	# 2bytes
			$index = ($strArray[$i] & 0x1f) <<  6;
			$index |= $strArray[$i+1] & 0x3f;
			$i++;
		} else {	# 3bytes
			$index = ($strArray[$i] & 0x0f) <<  12;
			$index |= ($strArray[$i+1] & 0x3f) <<  6;
			$index |= ($strArray[$i+2] & 0x3f);
			$i+=2;
		}
		$str .= $_unicode2sjis_table[$index];
	}
	
	$str;
}

# UNICODE escape줿Τ եJISѴ㡧%u3042ʤ  Ѵ
sub unicode_esc2sjis
{
	local(*str) = @_;
	my($i, $index, $work);

	if($utf82sjs_x_x_init == 0)	# Ѵơ֥ޤ
	{
		&loadutf82sjistable;
	}

	for($i = 0; $i >= 0 && $i < length($str); ) {
		;
		$i = index($str,'%u', $i);

		if($i >= 0)
		{
			$work = hex(substr($str, $i+2,4));
			substr($str,$i,6)=$_unicode2sjis_table[$work];
		}

	}
	
	$str;
}


# UNICODE escape줿Τ UTF-8Ѵ㡧%u3042ʤ  Ѵ
sub unicode_esc2utf8
{
	local(*str, $need_bom) = @_;
	my($i, $index, $work);

	for($i = 0; $i >= 0 && $i < length($str); ) {
		;
		$i = index($str,'%u', $i);

		if($i >= 0)
		{
			$work = hex(substr($str, $i+2,4));

			if($work <= 0x7F) {
				substr($str,$i,6)= pack("C1", $work);
			} elsif($work <= 0x7FF) {
				substr($str,$i,6) = pack("C2", 0xc0|($work >> 6), 0x80|($work & 0x3f ) );
				$i++;
			} else {
				substr($str,$i,6) = pack("C3", 0xe0|($work  >> 12), 0x80|(($work >> 6) & 0x3f), 0x80|($work & 0x3f ) );
				$i+=2;
			}

		}

	}

	if($need_bom != 0) {
		# BOMɤɲ
		$str = "\xEF\xBB\xBF$str";
	}
	$str;
}


1;
