﻿//<![CDATA[
	var map, marker;
	window.onload = function() {
		map = new GMap2(document.getElementById("map"));
		map.setCenter(new GLatLng(38.067554724225275,138.42086791992188), 10,G_NORMAL_MAP);
		map.setMapType(G_HYBRID_TYPE);
		map.addControl(new GLargeMapControl());
		map.addControl(new GScaleControl());
		map.addControl(new GMapTypeControl());
		map.enableDoubleClickZoom ();
		new GKeyboardHandler(map);
		gGeo = new GClientGeocoder();
		map.addControl(new GOverviewMapControl(new GSize(150,150)));
		var markObj = document.createElement("div");
		var mapW = parseInt(map.getContainer().style.width);
		var mapH = parseInt(map.getContainer().style.height);
		var markW = 18; // センターマークの横幅（ピクセル数）
		var markH = 18; // センターマークの縦幅（ピクセル数）
		var x = (mapW - markW) / 2; // センターマークの中心位置（X座標）
		var y = (mapH - markH) / 2; // センターマークの中心位置（Y座標）
		markObj.style.position = "absolute";
		markObj.style.top = y+"px";
		markObj.style.left = x+"px";
		markObj.style.backgroundImage = "url(img/center.gif)";
		markObj.style.backgroundRepeat = "no-repeat";
		markObj.style.width = markW+"px";
		markObj.style.height = markH+"px";
		markObj.style.opacity = 0.5;
		map.getContainer().appendChild(markObj);
		GEvent.addListener(map, "move", function(){
			var center = map.getBounds();
			var gtcent = center.getCenter();
			var latLng = gtcent.x + ',' + gtcent.y;
			document.getElementById("message").innerHTML = latLng;
		} );
	}
	function seeAt(lat, lng, title, body, size, url,img){
		var point = new GPoint(lat, lng);
		map.setZoom(13);
		var marker = new GMarker(point);
		map.panTo(new GLatLng(lng,lat));
		map.addOverlay(marker);
		GEvent.addListener(marker, "click", function() {
			var point = new GLatLng(lng,lat);
			tabList = [
				new GInfoWindowTab("情報１", "<b>"+title+"</b><p><div style='width:350px'>"+body+"</div></p>"),
				new GInfoWindowTab("画像", img),
				new GInfoWindowTab("関連ＨＰ", url)
			]
			marker.openInfoWindowTabsHtml(tabList);
		});
	}

	function searchPoint() {
		document.getElementById("result").innerHTML = "検索中です...";
		var address = document.getElementById("geoName").value;
		gGeo.getLatLng(address, checkGeo);
	}
	function checkGeo(point) {
		if (point) {
			map.setCenter(point, 14);
			document.getElementById("result").innerHTML = "中央が該当地点です";
		}else{
			document.getElementById("result").innerHTML = "見つかりませんでした";
		}
	}
//]]>
